#version 330

//uniform int g_Detail;

layout(lines) in;
layout(line_strip, max_vertices=32) out;
uniform float depth;
//layout(triangle_strip, max_vertices=64) out;

in _p2{
    vec4 p2;
} gs_in[];

//in ctrlpt {
//    vec2 p[4];
//} gs_in[];

//vec2 evaluateBezierPosition(vec2 pos[4], float t )
//{
//    float unmt = 1.0 - t;
//    float b0 = unmt*unmt*unmt;
//    float b1 = 3.0*t*unmt*unmt;
//    float b2 = 3.0*t*t*unmt;
//    float b3 = t*t*t;
//    return b0*pos[0] + b1*pos[1] + b2*pos[2] + b3*pos[3];
//}
 //vec4 evaluateBezierPosition(vec2 pos[4], float t )
 vec2 evaluateBezierPosition(vec2 pos[4], float t )
{
    float unmt = 1.0 - t;
	float tunmt6 = t*unmt*6;
	vec2 t2_unmt2 = vec2(t, unmt);
	t2_unmt2=t2_unmt2*t2_unmt2;
	vec2 t23_unmt23 = 3.0f * t2_unmt2;
    float b0 = unmt*t2_unmt2.y;
    float b1 = t*t23_unmt23.y;
    float b2 = t23_unmt23.x*unmt;
    float b3 = t*t2_unmt2.x;
	//float d0 = - t23_unmt23.y;
	//float d1 = t23_unmt23.y - tunmt6;
	//float d2 =tunmt6 - t23_unmt23.x;
	//float d3 =t23_unmt23.x;
    //return vec4(b0*pos[0] + b1*pos[1] + b2*pos[2] + b3*pos[3],
	//			normalize(d0*pos[0] + d1*pos[1] + d2*pos[2] + d3*pos[3]));
	return b0*pos[0] + b1*pos[1] + b2*pos[2] + b3*pos[3];
}
void main()
{
	vec2 pos[4];
  pos[0] = gs_in[0].p2.xy;
  pos[1] = gs_in[0].p2.zw;
  pos[2] = gs_in[1].p2.xy;
  pos[3] = gs_in[1].p2.zw;
  float OneOverDetail = 1.0 / 31;
  for( int i=0; i<32; i++ )
  {
      float t = i * OneOverDetail;
      vec2 p = evaluateBezierPosition(pos, t );
      gl_Position = vec4( p, depth, 1.0 );
      EmitVertex();
      //vec4 p = evaluateBezierPosition(pos, t );
      //gl_Position = vec4( p.xy + p.wz*0.005f, depth, 1.0 );
      //EmitVertex();
      //gl_Position = vec4( p.xy - p.wz*0.005f, depth, 1.0 );
      //EmitVertex();
  }
    EndPrimitive();
}