#version 420
layout(binding = 0) uniform usampler2D texture_region_id;
uniform int region_id;
uniform int region_new_id;

in vec2 pos;

layout(location = 0) out int color_out;

void main(void)
{
	if(region_id != texture(texture_region_id, pos).r)
		discard;
	color_out = region_new_id;
}
