#version 330
uniform sampler2D texture_region_id;
uniform sampler2D texture_out;
uniform int region_id;

in vec2 pos;
in vec4 color_in;

layout(location=0) out vec4 color_out;

void main(void)
{
	if(region_id != texture2D(texture_region_id, pos))
		discard;
	color_out = color_in;
}
