#version 420

layout(binding = 0) uniform usampler2D texture_region_id;
uniform float max_region_id_inverted;
in vec2 pos;
uniform float alpha;

layout(location=0) out vec4 color_out;

void main(void)
{
	//uint val = texture(texture_region_id, pos).r;
	uint val = texture(texture_region_id, pos).r;
	float indice_color = float(val)*max_region_id_inverted;
	//float indice_color = float(val)/65536.0f;
	//float indice_color = float(val)/65536.0f;
	
	//uint alpha_2 = uint(255.0f*255.0f*alpha);
	//vec3 m = mix(vec3(1.0f, 0.0f, 0.0f), vec3(0.0f, 1.0f, 0.0f), indice_color*2.0f);
	//m = mix(m, vec3(0.0f, 0.0f, 1.0f), indice_color*2.0f - 1.0f);
	//color_out = vec4(m, alpha);
	if(val==0)
		color_out = vec4(vec3(1.0f,0,0),alpha);
	else
		color_out = vec4(vec3(indice_color,indice_color,indice_color), alpha);
	
	//if(indice_color<1.0f/2.0f)
	//{
	//	color_out.r = 1.0f-indice_color*2.0f;
	//	color_out.g=indice_color*2.0f;
	//	color_out.b=0.0f;
	//	if(indice_color<1.0f/4.0f)
	//		color_out.b=indice_color*4.0f;
	//	else
	//		color_out.b=2.0f-indice_color*4.0f;
	//}
	//else
	//{
	//	color_out.r = 0.0f;
	//	color_out.g=2.0f-indice_color*2.0f;
	//	color_out.b=indice_color*2.0f - 1.0f;
	//	
	//	
	//	if(indice_color<3.0f/4.0f)
	//		color_out.r=indice_color*4.0f - 2.0f;
	//	else
	//		color_out.r=4.0f-indice_color*4.0f;
	//}
}
