#version 450

layout(binding = 0) uniform usampler2D texture_region_id_new;//id_1
layout(binding = 1) uniform sampler2D texture_region_color_ini;

in smooth vec2 pos;
in smooth vec4 color;
in flat ivec2 id;

layout(location = 0) out int id_out_1;//id_1   // it is merged
layout(location = 1) out int id_out_2;//id_2   // it is not merged
layout(location = 2) out vec4 error_map_;
layout(location = 3) out vec4 color_out;

void main(void)
{
	if(texture(texture_region_id_new, pos).r != id.x && texture(texture_region_id_new, pos).r != id.y)
		discard;
	id_out_1 = id.y;//put last id
	//if(reverse == 1)
	//	id_out_1 = id.y;//put last id
	//else
	//	id_out_1 = id.x;//put new id
	color_out = color;
	error_map_.r = distance(color_out, texture(texture_region_color_ini, pos));
	error_map_.b = 1.0f - error_map_.r;
	error_map_.g = 0.0f;
	error_map_.a = 1.0f;
	id_out_2 = id_out_1;
}
