#version 420
layout(binding=0) uniform sampler2D texture_ini;
layout(binding=1) uniform sampler2D texture_out;
uniform float alpha;

in vec2 pos;
layout(location=0) out vec4 color_ini;
layout(location=1) out vec4 color_new;

void main(void)
{

		color_ini = texture2D(texture_ini,pos);
		color_ini.a = alpha;
		color_new = texture2D(texture_out,pos);
		color_new.a = alpha;
}
