#version 450

layout(binding = 0) uniform usampler2D texture_region_id;
layout(binding = 1) uniform sampler2D texture_region_color;

in smooth vec2 pos;
//in flat int id;
uniform int id;
uniform float alpha;

layout(location = 0) out vec4 color_out;

void main(void)
{
	if(texture(texture_region_id, pos).r != id)
		discard;
		
	//color_out = vec4(texture2D(texture_region_color, pos),alpha);
	color_out = texture2D(texture_region_color,pos);//*0.4f+0.6f;
	color_out.a = alpha;
//	color_out.r=1.0f;
}
