#version 420

layout(location = 0) in vec3 vertex;
layout(location = 1) in vec2 tex;

uniform float s;
uniform vec2 t;
uniform float depth;
out vec2 pos;
out vec4 color;

uniform vec3 g;
uniform vec3 c;
uniform float a;
uniform float l_alpha;
uniform vec2 G;


void main(void)
{
	pos = tex;
	vec2 tmp = (vec2(vertex.x,-vertex.y)  + t)*s;
	gl_Position = vec4(tmp.x, tmp.y,depth,1.0f);
	float GX = dot(G, tex);//(tex * 0.5 + 0.5));
	color = vec4((c + g * GX).bgr, (a + l_alpha*GX));
	//color = color.bgr;
	
	
}

