#version 420
layout(binding=0) uniform sampler2D texture;

in vec2 pos;
out vec4 color;
uniform float alpha;

void main(void)
{
	float val = texture2D(texture,pos).r;
	if(val==0.0f)
		color = vec4(vec3(1.0f,0.0f,0.0f),alpha);
	else if(val==1.0f)
		color = vec4(vec3(0.0f,0.0f,1.0f),alpha);
	else
		color = vec4(val,val,val, alpha);
}
